# Introduction

First of all, thank you for considering contributing to Project64! Project64 is an open-source project and we love to receive contributions from the community. Contributions by the community help fix bugs, add new features, and improve the project. There are many ways to contribute, from writing and improving the documentation, testing, submitting bug reports and feature requests, or writing code which can be incorporated into Project64 itself.

If you are looking for support or need help, please join the [Discord](https://discord.gg/Cg3zquF)! It's the best way to get your questions answered quickly. Please do not open a GitHub issue without first reading through the [support document](../Docs/SUPPORT.md).

Following these guidelines will help make sure that users and developers alike can work together to achieve the projects goals.

Please do NOT post any copyrighted materials. This includes (but is not limited to) ROMs, ROM hacks, IPL and firmware files, etc.

Save states and game saves do not fall under this category, so please post them only if they are applicable to your issue!

# Github Contribution Guide

1. Create a fork of the repository on your own account.
2. Create a new branch from the `develop` branch.
  * Use helpful naming convention for the branch. (i.e. `fix`, `documentation`, etc.)
3. Commit the changes made on your new branch
4. If senisible, squash all of your commits into one. This will help clean up the process of vetting.
  * Esnure that commit messages are clear, consice, and infromative. They should include information about all changes made especially if you've squash multiple commits into one.
5. Once all commits have been made and squashed, rebase all changes in your branch.
  * Rebasing will resolve any merge confilcts that your changes may present
7. Create a pull request to the `develop` branch
  * The Pull request should be descriptive including any and all changes made to the code base. If multiple files have been changed, then organize the changes in a manner that is easy for a reviewer to follow.
  * Make sure that you **allow edits** by maintainers when making the Pull Request
8. Your changes should be reviewed and fixes may be made to your changes.
  * If fixes are made please make sure to address them

